package org.wsi.scm.servlet;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.wsi.scm.core.ejb.DemoSystemLocal;
import org.wsi.scm.core.ejb.DemoSystemLocalHome;
import org.wsi.scm.test.AbstractTest;
import org.wsi.scm.test.DemoSystemTest;
import org.wsi.scm.test.DemoSystemTest2;
import org.wsi.scm.test.DemoSystemTest3;
import org.wsi.scm.test.EventLogBeanTest;
import org.wsi.scm.test.InventoryBeanTest;
import org.wsi.scm.test.InventoryBeanTest2;
import org.wsi.scm.test.LoggingFacilityServiceTest;
import org.wsi.scm.test.LoggingFacilityServiceTest2;
import org.wsi.scm.test.ManufacturerBeanTest;
import org.wsi.scm.test.ManufacturerBeanTest2;
import org.wsi.scm.test.ManufacturerBeanTest3;
import org.wsi.scm.test.ManufacturerBeanTest4;
import org.wsi.scm.test.ManufacturerServiceATest;
import org.wsi.scm.test.RetailerBeanTest;
import org.wsi.scm.test.RetailerBeanTest2;
import org.wsi.scm.test.RetailerBeanTest3;
import org.wsi.scm.test.RetailerServiceTest;
import org.wsi.scm.test.RetailerServiceTest2;
import org.wsi.scm.test.RetailerServiceTest3;
import org.wsi.scm.test.WSITest1;
import org.wsi.scm.test.WSITest2;
import org.wsi.scm.test.WSITest3;
import org.wsi.scm.test.WSITest4;
import org.wsi.scm.test.WSITest5;
import org.wsi.scm.test.WSITest6;
import org.wsi.scm.test.WarehouseBeanTest;
import org.wsi.scm.test.WarehouseBeanTest2;
import org.wsi.scm.test.WarehouseBeanTest3;
import org.wsi.scm.test.WarehouseCallbackServiceTest;
import org.wsi.scm.test.WarehouseServiceATest;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

public class TestServlet extends HttpServlet
{
	protected void doGet(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException
	{
		doPost(request, response);
	}

	protected void doPost(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException
	{
		try {
		
		// prepare the test catalog
		ArrayList tests = new ArrayList();
		tests.add(new EventLogBeanTest());
		tests.add(new DemoSystemTest());
		tests.add(new DemoSystemTest2());
		tests.add(new DemoSystemTest3());
		tests.add(new InventoryBeanTest());
		tests.add(new InventoryBeanTest2());
		tests.add(new ManufacturerBeanTest());
		tests.add(new ManufacturerBeanTest2());
		tests.add(new ManufacturerBeanTest3());
		tests.add(new ManufacturerBeanTest4());
		tests.add(new RetailerBeanTest());
		tests.add(new RetailerBeanTest2());
		tests.add(new RetailerBeanTest3());
		tests.add(new ManufacturerServiceATest());	
		tests.add(new WarehouseBeanTest());
		tests.add(new WarehouseBeanTest2());
		tests.add(new WarehouseBeanTest3());
		tests.add(new WarehouseServiceATest());
		tests.add(new WarehouseCallbackServiceTest());
		tests.add(new RetailerServiceTest());
		tests.add(new RetailerServiceTest2());
		tests.add(new RetailerServiceTest3());
		tests.add(new LoggingFacilityServiceTest());
		tests.add(new LoggingFacilityServiceTest2());
		
		tests.add(new WSITest1());
		tests.add(new WSITest2());
		tests.add(new WSITest3());
		tests.add(new WSITest4());
		tests.add(new WSITest5());
		tests.add(new WSITest6());
	
		
		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
		out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 " 
				+ "Transitional//EN\">\n");
		out.println("<HTML>");
		out.println("<HEAD>");
		out.println("\t<TITLE>Unit Test for the WS-I Sample Application</TITLE>");
		printCheckAllJavaScript(out);
		out.println("</HEAD>");
		out.println("<BODY>");

		ArrayList testsToRun = new ArrayList();
		String[] testNames = request.getParameterValues("list");
		if (testNames != null) {
			for (int j = 0; j < testNames.length; j++) {
				testsToRun.add(testNames[j]);
			}
		}
		
		String initdb = request.getParameter("resetdb");
		if (initdb != null)
		{
			// init wsi test db
			DemoSystemLocalHome demoSysHome =
				(DemoSystemLocalHome) ServiceLocator.getInstance().getLocalHome(
					Constants.SESSION_DEMOSYSTEM);
				
			DemoSystemLocal demoSys = demoSysHome.create();
		
			demoSys.resetDBContent();			
		}
		
		out.println("Start tests at " + new Date(System.currentTimeMillis()) + "<BR/><BR/>");
		
		out.println("<FORM ACTION=\"http://localhost:53000/MAIN_WSISAMPL_D~test~wsi-test~sap.com/servlet/org.wsi.scm.servlet.TestServlet\">");
		// table definition and header row.
		out.println("<TABLE border=\"1\">");
		out.println("<TR>");
		out.println("\t<TH>run</TH>");
		out.println("\t<TH>Test Name</TH>");
		out.println("\t<TH>Description</TH>");
		out.println("\t<TH>Test Result</TH>");
		out.println("\t<TH>Log File</TH>");
		out.println("\t<TH>Error Message</TH>");
		out.println("</TR>");
				
		Iterator iter = tests.iterator();
		int i = 0;
		while (iter.hasNext()) {
			AbstractTest test = (AbstractTest)iter.next();
			out.println("<TR>");
			out.println("\t<TD><input type=\"checkbox\" name=\"list\" value=\"" + test.getTestName()+ "\"/></TD>");
			out.println("\t<TD>"+test.getTestName()+"</TD>");
			out.println("\t<TD>"+test.getDescription()+"</TD>");
			if (testsToRun.contains(test.getTestName())) {			
				boolean success = test.execute();
				if (success) {
					out.println("\t<TD><font color=\"green\">SUCCESS</TD>");
				} else {
					out.println("\t<TD><font color=\"red\"><b>FAILURE</b></TD>");
				}
			} else {
				out.println("\t<TD>not run</TD>");
			}
			out.println("\t<TD><A href=\"file://" + test.getLogName() + "\">log file</A></TD>");
			out.println("\t<TD>" + test.getErrorMessage() + "</TD>");
		  out.println("</TR>");
		}							
		out.println("</TABLE>");
		out.println("<input type=button value=\"Check All\" onClick=\"this.value=check(this.form.list)\">");
		out.println("<INPUT TYPE=\"SUBMIT\" NAME=\"RUN\" VALUE=\"RUN TESTS\">");
		out.println("&nbsp;Reset DB <INPUT TYPE=\"checkbox\" name=\"resetdb\"");
		out.println("</FORM></BODY></HTML>");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void printCheckAllJavaScript(PrintWriter out) {

		out.println("<SCRIPT LANGUAGE=\"JavaScript\">");
		out.println("var checkflag = \"false\";");
		out.println("function check(field) {");
		out.println("if (checkflag == \"false\") {");
		out.println("for (i = 0; i < field.length; i++) {");
		out.println("field[i].checked = true;}");
		out.println("checkflag = \"true\";");
		out.println("return \"Uncheck All\"; }");
		out.println("else {");
		out.println("for (i = 0; i < field.length; i++) {");
		out.println("field[i].checked = false; }");
		out.println("checkflag = \"false\";");
		out.println("return \"Check All\"; }");
		out.println("}");
		out.println("</SCRIPT>");
	}
}

