package org.wsi.scm.test;


import org.wsi.scm.core.bo.configuration.ConfigurationType;
import org.wsi.scm.core.bo.manufacturer.Item;
import org.wsi.scm.core.bo.manufacturer.ItemList;
import org.wsi.scm.core.bo.manufacturer.PurchOrdType;
import org.wsi.scm.core.bo.manufacturer.StartHeaderType;
import org.wsi.scm.core.ejb.ManufacturerALocal;
import org.wsi.scm.core.ejb.ManufacturerALocalHome;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

public class ManufacturerBeanTest extends AbstractTest {

	public String getTestName() {
		return "ManufacturerBeanTest";
	}
	
	public String getDescription() {
		return "Tests shipping from production run.";
	}
	
	public void doTest() throws Exception {
		
		log.println("getting context, bean");	
			
		ManufacturerALocalHome manufacturerAHome =
			(ManufacturerALocalHome) ServiceLocator.getInstance().getLocalHome(
				Constants.SESSION_MANUFACTURERA);
		log.println("got home.");
			
		ManufacturerALocal manufacturerA = manufacturerAHome.create();
		log.println("created bean");

		PurchOrdType poType = new PurchOrdType();
		
		ConfigurationType configurationHeader = getDefaultConfiguration();
		
		StartHeaderType startHeader = new StartHeaderType();
		poType.setCustomerReference("custRef");
		poType.setOrderNum("someOrderNumber");
		ItemList items = new ItemList();
		Item item = new Item();
		item.setID(new Long(605001));
		item.setPrice(new Float(2.2));
		item.setQty(new Integer(100));
		Item[] itemArray = new Item[1];
		itemArray[0] = item;
		items.setItem(itemArray);
		poType.setItems(items);

		log.println("created call, invoking method...");
		Boolean result = manufacturerA.submitPO(poType.getOrderNum(), poType.getCustomerReference(), poType.getItems(), poType.getTotal());
		log.println("got: " + result.booleanValue());
	}
}
