/*
 * WS-I Sample Application 1.0
 * 
 * Copyright (c) 2005 by SAP AG. 
 * All Rights Reserved.
 * 
 */
package org.wsi.scm.test;

import java.math.BigDecimal;
import java.math.BigInteger;

import javax.naming.Context;

import org.wsi.scm.proxy.retailerUI.RetailerServiceUI;
import org.wsi.scm.proxy.retailerUI.RetailerServiceUIViDocument;
import org.wsi.scm.proxy.retailerUI.types.CustomerDetailsType;
import org.wsi.scm.proxy.retailerUI.types.PartsOrderItem;
import org.wsi.scm.proxy.retailerUI.types.PartsOrderResponseItem;
import org.wsi.scm.proxy.retailerUI.types.PartsOrderResponseType;
import org.wsi.scm.proxy.retailerUI.types.PartsOrderType;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;


public class RetailerServiceTest extends AbstractTest
{

	public String getTestName()
	{
		return "RetailerServiceUITest";
	}

	public String getDescription() {
		return "Tests submitOrder retailer web service for UI (config header as param), orders 1 605001";
	}

	public void doTest() throws Exception
	{
		Context ctx = ServiceLocator.getInstance().getContext();

		RetailerServiceUI ws =
			(RetailerServiceUI) ctx.lookup(
				Constants.JNDI_SERVICE_PREFIX
					+ Constants.WSPROXY_RETAILERUI_SERVICE);
		RetailerServiceUIViDocument retailer =
			(RetailerServiceUIViDocument) ws.getLogicalPort();

		PartsOrderItem[] items = new PartsOrderItem[1];
		items[0] = new PartsOrderItem();
		items[0].setPrice(new BigDecimal(2.2));
		items[0].setProductNumber(BigInteger.valueOf(605001));
		items[0].setQuantity(BigInteger.valueOf(1));
		PartsOrderType partsOrder = new PartsOrderType();
		partsOrder.setItem(items);
		
		CustomerDetailsType customerDetails = new CustomerDetailsType();
		customerDetails.setCustnbr("1234");

		retailer._setProperty("javax.xml.rpc.http.proxyhost","localhost");
		retailer._setProperty("javax.xml.rpc.http.proxyport","50012");
		
		PartsOrderResponseType response = retailer.submitOrderUI(partsOrder, customerDetails, "abc");		
				
		PartsOrderResponseItem[] responseItems = response.getItem();
		log.println("responselength:" +responseItems.length);
		for (int i = 0; i < responseItems.length; i++) {
			log.println("got: " + responseItems[i].getProductNumber());
			log.println("\t" + responseItems[i].getPrice());
			log.println("\t" + responseItems[i].getQuantity());
		}	


	}
}		