package org.wsi.scm.test;

import javax.naming.Context;

import org.wsi.scm.proxy.retailer.RetailerService;
import org.wsi.scm.proxy.retailer.RetailerServiceViRpc;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

public class RetailerServiceTest3 extends AbstractTest
{

	public String getTestName()
	{
		return "RetailerServiceTest3";
	}

	public String getDescription()
	{
		return "Tests the getCatalog function with security.";
	}

	public void doTest() throws Exception
	{
		Context ctx = ServiceLocator.getInstance().getContext();

		RetailerService ws =
			(RetailerService) ctx.lookup(Constants.JNDI_SERVICE_PREFIX + Constants.WSPROXY_RETAILER_SERVICE);
		RetailerServiceViRpc retailerSecure =
			(RetailerServiceViRpc) ws.getLogicalPort("SecurePort");

		retailerSecure._setProperty(
			RetailerServiceViRpc.ENDPOINT_ADDRESS_PROPERTY,
			"http://localhost:53000/RetailerService/RetailerSecure?style=rpc");
				
		retailerSecure._setProperty("javax.xml.rpc.http.proxyhost","localhost");
		retailerSecure._setProperty("javax.xml.rpc.http.proxyport","50012");

		retailerSecure.getCatalog();

	}
}