
package org.wsi.scm.test;

import org.wsi.scm.core.bo.configuration.Config;
import org.wsi.scm.core.bo.configuration.ConfigData;
import org.wsi.scm.core.ejb.DemoSystemLocal;
import org.wsi.scm.core.ejb.DemoSystemLocalHome;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

public class DemoSystemTest3 extends AbstractTest
{

	
	public String getTestName()
	{
		return "DemoSystemTest3";
	}

	
	public String getDescription()
	{
		return "This tests the demo system bean saveConfig method.";
	}


	public void doTest() throws Exception
	{
		DemoSystemLocalHome demoSysHome =
			(DemoSystemLocalHome) ServiceLocator.getInstance().getLocalHome(
				Constants.SESSION_DEMOSYSTEM);
				
		DemoSystemLocal demoSys = demoSysHome.create();
		
		Config newConfig = new Config();
		newConfig.setDescription("TestConfig");
		newConfig.setProfile("BSP");
		
		ConfigData[] configData = new ConfigData[8];
		configData[0] = new ConfigData();
		configData[0].setDescription("ConfigData1");
		configData[0].setRoleName(Constants.ROLE_LOGGING_FACILITY);
		configData[0].setServiceUrl("http://test1.com");
		
		configData[1] = new ConfigData();
		configData[1].setDescription("ConfigData2");
		configData[1].setRoleName(Constants.ROLE_RETAILER);
		configData[1].setServiceUrl("http://test2.com");
		
		configData[2] = new ConfigData();
		configData[2].setDescription("ConfigData2");
		configData[2].setRoleName(Constants.ROLE_MANUFACTURER_A);
		configData[2].setServiceUrl("http://test2.com");		
				
		configData[3] = new ConfigData();
		configData[3].setDescription("ConfigData3");
		configData[3].setRoleName(Constants.ROLE_MANUFACTURER_B);
		configData[3].setServiceUrl("http://test3.com");
		
		configData[4] = new ConfigData();
		configData[4].setDescription("ConfigData4");
		configData[4].setRoleName(Constants.ROLE_MANUFACTURER_C);
		configData[4].setServiceUrl("http://test4.com");
		
		configData[5] = new ConfigData();
		configData[5].setDescription("ConfigData5");
		configData[5].setRoleName(Constants.ROLE_WAREHOUSE_A);
		configData[5].setServiceUrl("http://test5.com");
		
		configData[6] = new ConfigData();
		configData[6].setDescription("ConfigData6");
		configData[6].setRoleName(Constants.ROLE_WAREHOUSE_B);
		configData[6].setServiceUrl("http://test6.com");
		
		configData[7] = new ConfigData();
		configData[7].setDescription("ConfigData7");
		configData[7].setRoleName(Constants.ROLE_WAREHOUSE_C);
		configData[7].setServiceUrl("http://test7.com");		
		
		newConfig.setConfigData(configData);
		newConfig.setConfigID(new Long(123));
		
		demoSys.saveConfig(newConfig);		
	}

}
