
package org.wsi.scm.test;

import org.wsi.scm.core.ejb.EventLogLocal;
import org.wsi.scm.core.ejb.EventLogLocalHome;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

public class EventLogBeanTest extends AbstractTest
{
	public String getTestName() {
		return "EventLogBeanTest";
	}

	public String getDescription() {
		return "Test adding an event to the db via entity bean and retrieves it.";
	}

	public void doTest() throws Exception
	{
		log.println("Getting bean instance: " + Constants.ENTITY_EVENTLOG);
		EventLogLocalHome eventLogHome =
			(EventLogLocalHome) ServiceLocator.getInstance().getLocalHome(
				Constants.ENTITY_EVENTLOG);
		log.println("Got bean instance.");

		String serverId = "someServerId";
		String serviceId = "someServiceId";
		String demoId = String.valueOf(System.currentTimeMillis());
		String useCaseId = "UCx";
		String userId = "someUserId";
		String desc = "someDesc";

		log.println("Creating log event: " + demoId);
		EventLogLocal eventLog =
			eventLogHome.create( 
				serverId,
				demoId,
				serviceId,
				useCaseId,
				userId,
				desc);
		log.println("logged event:" + eventLog.getPrimaryKey());
		
		EventLogLocal log2 = eventLogHome.findByPrimaryKey(eventLog.getPrimaryKey());

		if (demoId.equals(log2.getDemoID())) {
			log.println("demo ids are equal" + demoId);
		} else {
			throw new Exception("demo ids aren't equal");
		}
		
		
		if (serverId.equals(log2.getServerID())) {
			log.println("server ids are equal:" + serverId);
		} else {
			throw new Exception("server ids aren't equal: " + serverId + " " + log2.getServerID());
		}
		
		if (serviceId.equals(log2.getServiceID())) {
			log.println("service ids are equal: " + serviceId);
		} else {
			throw new Exception("service ids aren't equal: " + serviceId + " " + log2.getServiceID());
		}
			
		if (useCaseId.equals(log2.getUseCaseID())) {
			log.println("use case ids are equal: " + useCaseId);
		} else {
			throw new Exception("use case ids aren't equal: " + useCaseId + " " + log2.getUseCaseID());
		}
		
		if (userId.equals(log2.getUserID())) {
			log.println("user ids are equal: " + userId);
		} else {
			throw new Exception("user ids aren't equal:" + userId + " " + log2.getUserID());
		}

		if (desc.equals(log2.getDescription())) {
			log.println("descriptions are equal:" + log2.getDescription());
		} else {
			throw new Exception("descriptions aren't equal: " + desc + " " + log2.getDescription());
		}
	}
}
