package org.wsi.scm.test;

import javax.naming.Context;

import org.wsi.scm.proxy.loggingfacility.LoggingFacilityService;
import org.wsi.scm.proxy.loggingfacility.LoggingFacilityServiceViDocument;
import org.wsi.scm.proxy.loggingfacility.types.LogEventRequestElement;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

public class LoggingFacilityServiceTest extends AbstractTest
{

	public String getTestName()
	{
		return "LoggingFacilityServiceTest";
	}

	public String getDescription()
	{
		return "Tests logging of an event via the logging facility web service";
	}

	public void doTest() throws Exception
	{

		log.println("getting context.");
		Context ctx = ServiceLocator.getInstance().getContext();
		LoggingFacilityService ws =
			(LoggingFacilityService) ctx.lookup(
				Constants.JNDI_SERVICE_PREFIX + Constants.WSPROXY_LOGGING_FACILITY_SERVICE);
		LoggingFacilityServiceViDocument service = (LoggingFacilityServiceViDocument) ws.getLogicalPort();
		
		service._setProperty("javax.xml.rpc.http.proxyhost","localhost");
		service._setProperty("javax.xml.rpc.http.proxyport","50012");		
		
		String eventDesc = String.valueOf(System.currentTimeMillis());
		log.println("logging event: " + eventDesc);
		LogEventRequestElement event = new LogEventRequestElement();
		event.setEventDescription("testEventDescription");
		event.setDemoUserID("testDemoUserID");
		event.setEventID("testEventId");
		event.setServiceID("testServiceId");

		service.logEvent(event.getDemoUserID(), event.getServiceID(), event.getEventID(), event.getEventDescription());

		log.println("logged event.");
	}
}