package org.wsi.scm.test;

import javax.naming.Context;

import org.wsi.scm.proxy.loggingfacility.LoggingFacilityService;
import org.wsi.scm.proxy.loggingfacility.LoggingFacilityServiceViDocument;
import org.wsi.scm.proxy.loggingfacility.types.LogEntry;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

public class LoggingFacilityServiceTest2 extends AbstractTest
{

	public String getTestName()
	{
		return "LoggingFacilityServiceTest2";
	}

	public String getDescription()
	{
		return "Tests retrieval of events via the logging facility web service";
	}

	public void doTest() throws Exception
	{		
		log.println("getting context.");
		Context ctx = ServiceLocator.getInstance().getContext();
		LoggingFacilityService ws =
			(LoggingFacilityService) ctx.lookup(
				Constants.JNDI_SERVICE_PREFIX + Constants.WSPROXY_LOGGING_FACILITY_SERVICE);
		LoggingFacilityServiceViDocument service = (LoggingFacilityServiceViDocument) ws.getLogicalPort();
				
		service._setProperty("javax.xml.rpc.http.proxyhost","localhost");
		service._setProperty("javax.xml.rpc.http.proxyport","50012");	
				
		LogEntry[] logEntries = service.getEvents("testDemoUserID");
		
		log.println("got " + logEntries.length + " events for demoUserId 'testDemoUserID'.");
	}

}
