package org.wsi.scm.test;

import org.wsi.scm.core.bo.configuration.ConfigurationType;
import org.wsi.scm.core.bo.manufacturer.Item;
import org.wsi.scm.core.bo.manufacturer.ItemList;
import org.wsi.scm.core.bo.manufacturer.PurchOrdType;
import org.wsi.scm.core.bo.manufacturer.StartHeaderType;
import org.wsi.scm.core.ejb.ManufacturerALocal;
import org.wsi.scm.core.ejb.ManufacturerALocalHome;
import org.wsi.scm.core.exception.POFaultException;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;


public class ManufacturerBeanTest2 extends AbstractTest {

	public String getTestName() {
		return "ManufacturerBeanTest2";
	}
	
	public String getDescription() {
		return "Tests invalid PO, i.e. a wrong product id for the manufacturer.";
	}
	
	public void doTest() throws Exception {
		
		log.println("getting context, bean");	
			
		ManufacturerALocalHome manufacturerAHome =
			(ManufacturerALocalHome) ServiceLocator.getInstance().getLocalHome(
				Constants.SESSION_MANUFACTURERA);
		log.println("got home.");
			
		ManufacturerALocal manufacturerA = manufacturerAHome.create();
		log.println("created bean");

		ConfigurationType configurationHeader = getDefaultConfiguration();
		
		PurchOrdType poType = new PurchOrdType();
		StartHeaderType startHeader = new StartHeaderType();
		poType.setCustomerReference("custRef");
		poType.setOrderNum("someOrderNumber");
		ItemList itemList = new ItemList();		
		Item[] items = new Item[1];
		Item item = new Item();
		item.setID(new Long(605002));
		item.setPrice(new Float(2.2));
		item.setQty(new Integer(100));
		items[0] = item;
		itemList.setItem(items);
		poType.setItems(itemList);

		boolean caughtExpected = false;
		try {	
			log.println("created call, invoking method...");
			Boolean result = manufacturerA.submitPO(poType.getOrderNum(), poType.getCustomerReference(), poType.getItems(), poType.getTotal());
			log.println("got: " + result.booleanValue());
		} catch (POFaultException p) {
			caughtExpected = true;
			// success..., all other exceptions should be thrown.
		}
		
		if (!caughtExpected) {
			throw new Exception("didn't catch POFaultException as expected.");
		}
		
	}
}
