package org.wsi.scm.test;

import java.rmi.RemoteException;

import javax.naming.Context;

import org.wsi.scm.proxy.manufacturer.ManufacturerService;
import org.wsi.scm.proxy.manufacturer.ManufacturerServiceAViDocument;
import org.wsi.scm.proxy.manufacturer.types.Item;
import org.wsi.scm.proxy.manufacturer.types.PurchaseOrder;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

import com.sap.engine.services.webservices.jaxrpc.exceptions.XmlUnmarshalException;

public class ManufacturerServiceATest extends AbstractTest
{

	public String getTestName()
	{
		return "ManufacturerServiceATest";
	}

	public String getDescription()
	{
		return "Tests the manufacturer A service.";
	}

	public void doTest() throws Exception
	{
		Context ctx = ServiceLocator.getInstance().getContext();

		ManufacturerService ms =
			(ManufacturerService) ctx.lookup(Constants.JNDI_SERVICE_PREFIX + Constants.WSPROXY_MANUFACTURER_SERVICE);
		ManufacturerServiceAViDocument manufacturerA =
			(ManufacturerServiceAViDocument) ms.getLogicalPort("MFAWHASecurePort");

		PurchaseOrder purchaseOrder = new PurchaseOrder();
		purchaseOrder.setCustomerRef("CustomerRef");
		purchaseOrder.setOrderNum("OrderNum");
		purchaseOrder.setTotal(new Float("2.3"));

		Item item = new Item();
		item.setId(new Long("1000"));
		item.setPrice(new Float("2.3"));
		item.setQty(new Integer("2"));
		Item[] items = new Item[1];
		items[0] = item;

		purchaseOrder.setItems(items);

		manufacturerA._setProperty("javax.xml.rpc.http.proxyhost", "localhost");
		manufacturerA._setProperty("javax.xml.rpc.http.proxyport", "50012");
		
		manufacturerA._setProperty(
			ManufacturerServiceAViDocument.ENDPOINT_ADDRESS_PROPERTY, Constants.DEFAULTLOCATION_MANUFACTURERA);		

		try
		{
			Boolean response =
				manufacturerA.submitPO(
					purchaseOrder.getOrderNum(),
					purchaseOrder.getCustomerRef(),
					purchaseOrder.getItems(),
					purchaseOrder.getTotal());
		}
		catch (RemoteException e)
		{
			if (e.getCause() instanceof XmlUnmarshalException)
			{
				e.printStackTrace();
			}
			else
				throw new RemoteException(e.getMessage());
		}
	}

}
