package org.wsi.scm.test;

import java.math.BigDecimal;
import java.math.BigInteger;

import org.wsi.scm.core.bo.retailer.CustomerDetailsType;
import org.wsi.scm.core.bo.retailer.PartsOrderItem;
import org.wsi.scm.core.bo.retailer.PartsOrderResponseItem;
import org.wsi.scm.core.bo.retailer.PartsOrderResponseType;
import org.wsi.scm.core.bo.retailer.PartsOrderType;
import org.wsi.scm.core.ejb.RetailerSystemLocal;
import org.wsi.scm.core.ejb.RetailerSystemLocalHome;
import org.wsi.scm.core.exception.InvalidProductCodeException;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

public class RetailerBeanTest3 extends AbstractTest
{
	
	public String getTestName() {
		return "RetailerBeanTest3";
	}
	
	public String getDescription() {
		return "Tests InvalidProductCode by ordering 605010.";
	}
	
	public void doTest() throws Exception {
		boolean gotExpectedResult = false;
		try {
	
			RetailerSystemLocalHome retSysHome =
				(RetailerSystemLocalHome) ServiceLocator.getInstance().getLocalHome(
					Constants.SESSION_RETAILERSYSTEM);
					
			RetailerSystemLocal retailer = retSysHome.create();
			
			PartsOrderItem[] items = new PartsOrderItem[1];
			items[0] = new PartsOrderItem();
			items[0].setPrice(new BigDecimal(2.2));
			items[0].setProductNumber(BigInteger.valueOf(605010));
			items[0].setQuantity(BigInteger.valueOf(1));
			PartsOrderType partsOrder = new PartsOrderType();
			partsOrder.setItem(items);
			CustomerDetailsType customerDetails = new CustomerDetailsType();
			customerDetails.setCustnbr("1234");
						
			PartsOrderResponseType response = 
					retailer.submitOrder(partsOrder, customerDetails);
			
			PartsOrderResponseItem[] responseItems = response.getItem();
			for (int i = 0; i < responseItems.length; i++) {
				log.println("got " + responseItems[i].getQuantity() + " of " 
						+ responseItems[i].getProductNumber() + " for "  
						+ responseItems[i].getPrice());
			}	
		} catch (InvalidProductCodeException ex) {
			gotExpectedResult = true;
		}
		if (!gotExpectedResult) {
			throw new Exception("Expected to catch invalid product code.");
		}
	}

}
