package org.wsi.scm.test;

import org.wsi.scm.core.bo.warehouse.Item;
import org.wsi.scm.core.bo.warehouse.ItemList;
import org.wsi.scm.core.bo.warehouse.ItemShippingStatus;
import org.wsi.scm.core.bo.warehouse.ItemShippingStatusList;
import org.wsi.scm.core.ejb.WarehouseALocal;
import org.wsi.scm.core.ejb.WarehouseALocalHome;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

public class WarehouseBeanTest extends AbstractTest
{
	
	public String getTestName() {
		return "WarehouseBeanTest";
	}
	
	public String getDescription() {
		return "Tests the warehouse shipGoods, orders 1 of 605001, no order nec.";
	}
	
	public void doTest() throws Exception {
		
		log.println("getting context, bean");			
		WarehouseALocalHome warehouseAHome =
			(WarehouseALocalHome) ServiceLocator.getInstance().getLocalHome(
				Constants.SESSION_WAREHOUSEA);
		log.println("got home.");		
		WarehouseALocal warehouseA = warehouseAHome.create();
		log.println("created bean");
		

		Item[] items = new Item[1];
		Item item1 = new Item();		
		item1.setProductNumber(new Long(605001));
		item1.setQuantity(new Integer(1));
		items[0] = item1;
		ItemList itemList = new ItemList();
		itemList.setItem(items);
		String ref = new String("someCustRef");
							
		ItemShippingStatusList statusList =	warehouseA.ShipGoods(itemList, ref);			
		ItemShippingStatus[] status = statusList.getItemStatus();
		if (status != null) {
			for (int i = 0; i < status.length; i++) {
				log.println(status[i].isStatus() + " : "+ status[i].getProductNumber());
			}
		} else {
			log.println("ERROR: ship goods returned null.");
			throw new Exception("ERROR: ship goods returned null");
		}
	}
}
