package org.wsi.scm.test;

import javax.naming.Context;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.wsi.scm.proxy.demo.DemoService;
import org.wsi.scm.proxy.demo.DemoServiceViDocument;
import org.wsi.scm.proxy.demo.types.Config;
import org.wsi.scm.proxy.demo.types.ConfigData;
import org.wsi.scm.proxy.warehouse.WarehouseService;
import org.wsi.scm.proxy.warehouse.WarehouseServiceAViRpc;
import org.wsi.scm.proxy.warehouse.types.Item;
import org.wsi.scm.proxy.warehouse.types.ItemList;
import org.wsi.scm.util.Constants;
import org.wsi.scm.util.ServiceLocator;

import com.sap.engine.services.webservices.jaxrpc.wsdl2java.BaseGeneratedStub;
import com.sap.engine.services.webservices.jaxrpc.wsdl2java.features.builtin.SoapHeadersProtocol;

public class WarehouseServiceATest extends AbstractTest
{

	public String getTestName()
	{
		return "WarehouseServiceATest";
	}

	public String getDescription()
	{
		return "Tests the warehouse a service.";
	}

	public void doTest() throws Exception
	{
		Context ctx = ServiceLocator.getInstance().getContext();

		WarehouseService ws =
			(WarehouseService) ctx.lookup(Constants.JNDI_SERVICE_PREFIX + Constants.WSPROXY_WAREHOUSE_SERVICE);
		WarehouseServiceAViRpc warehouseA = (WarehouseServiceAViRpc) ws.getLogicalPort();

		DemoService ds = (DemoService) ctx.lookup(Constants.JNDI_SERVICE_PREFIX + Constants.WSPROXY_DEMO_SERVICE);
		DemoServiceViDocument demo = (DemoServiceViDocument) ds.getLogicalPort();

		ItemList itemList = new ItemList();

		Item[] item = new Item[1];
		item[0] = new Item();
		item[0].setProductNumber(new Long("12345"));
		item[0].setQuantity(new Integer("2"));

		itemList.setItem(item);

		SoapHeadersProtocol headers =
			(SoapHeadersProtocol) ((BaseGeneratedStub) warehouseA)._getGlobalProtocols().getProtocol(
				"SoapHeadersProtocol");

		// build config header from demo service call to getConfigFromDB
		Config[] config = demo.getConfigFromDB();

		// create header from first element in config (e.g. 'public'
		ConfigData[] configData = config[0].getConfigData();

		// root element of config header
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
		Document doc = docBuilder.newDocument();
		Element parameterNode =
			doc.createElementNS(
				Constants.SOAPHEADER_CONFIG_NAMESPACE,
				Constants.SOAPHEADER_CONFIG_NAMESPACE_PREFIX + Constants.SOAPHEADER_CONFIG_TAGNAME_ROOT);

		Element valueNodeUser = doc.createElement(Constants.SOAPHEADER_CONFIG_NAMESPACE_PREFIX + "UserId");
		valueNodeUser.appendChild(doc.createTextNode("testValue"));
		// parameterNode.setAttributeNS("http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd","wsu4:Id","Configuration");		

		// iterate over entries in config data and build XML element for config header
		for (int i = 0; i < configData.length; i++)
		{
			ConfigData endpointConfiguration = configData[i];

			Element valueNodeLoggingConfig =
				doc.createElement(
					Constants.SOAPHEADER_CONFIG_NAMESPACE_PREFIX + Constants.SOAPHEADER_CONFIG_TAGNAME_SERVICE);
			valueNodeLoggingConfig.setAttribute(
				Constants.SOAPHEADER_CONFIG_ATTRIBUTENAME_ROLE,
				endpointConfiguration.getRoleName());
			valueNodeLoggingConfig.appendChild(doc.createTextNode(endpointConfiguration.getServiceUrl()));

			parameterNode.appendChild(valueNodeUser);
			parameterNode.appendChild(valueNodeLoggingConfig);
		}

		headers.setOutputHeader(null, parameterNode);

		warehouseA._setProperty("javax.xml.rpc.http.proxyhost", "localhost");
		warehouseA._setProperty("javax.xml.rpc.http.proxyport", "50012");

		warehouseA.shipGoods(itemList.getItem(), "customer");		
	}
}